DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Member Functions | Private Attributes | List of all members
DVPSGraphicLayer Class Reference

an item of the graphic layer sequence in a presentation state (internal use only). More...

## Public Member Functions
| DVPSGraphicLayer ()
| default constructor
| DVPSGraphicLayer (const DVPSGraphicLayer &copy)
| copy constructor
DVPSGraphicLayer * | clone ()
| clone method. More...
virtual | ~DVPSGraphicLayer ()
| destructor
OFCondition | read (DcmItem &dset)
| reads a graphic layer from a DICOM dataset. More...
OFCondition | write (DcmItem &dset)
| writes the graphic layer managed by this object to a DICOM dataset. More...
const char * | getGL ()
| get graphic layer name of this layer. More...
const char * | getGLDescription ()
| get graphic layer description of this layer. More...
Sint32 | getGLOrder ()
| gets the graphic layer order of this layer. More...
OFBool | haveGLRecommendedDisplayValue ()
| checks whether a recommended display value (grayscale, color or both) exists. More...
OFCondition | getGLRecommendedDisplayValueGray (Uint16 &gray)
| gets the recommended grayscale display value. More...
OFCondition | getGLRecommendedDisplayValueRGB (Uint16 &r, Uint16 &g, Uint16 &b)
| gets the recommended RGB display value. More...
OFCondition | getGLRecommendedDisplayValueCIELab (Uint16 &L, Uint16 &a, Uint16 &b)
| gets the recommended CIELAB display value. More...
void | removeRecommendedDisplayValue (OFBool cielab, OFBool monochrome)
| removes recommended display values. More...
void | setGL (const char *gl)
| set graphic layer name of this layer. More...
void | setGLOrder (Sint32 glOrder)
| set graphic layer order of this layer. More...
void | setGLRecommendedDisplayValueGray (Uint16 gray)
| set graphic layer recommended grayscale display value of this layer. More...
void | setGLRecommendedDisplayValueRGB (Uint16 r, Uint16 g, Uint16 b)
| set graphic layer recommended CIELAB display value of this layer by converting RGB to CIELAB. More...
void | setGLRecommendedDisplayValueCIELab (Uint16 L, Uint16 a, Uint16 b)
| set graphic layer recommended CIELAB display value of this layer. More...
void | setGLDescription (const char *glDescription)
| set graphic layer description of this layer. More...

## Private Member Functions
DVPSGraphicLayer & | operator= (const DVPSGraphicLayer &)
| private undefined assignment operator

## Private Attributes
DcmCodeString | graphicLayer
| VR=CS, VM=1, Type 1.
DcmIntegerString | graphicLayerOrder
| VR=IS, VM=1, Type 1.
DcmUnsignedShort | graphicLayerRecommendedDisplayGrayscaleValue
| VR=US, VM=1, Type 3.
DcmUnsignedShort | graphicLayerRecommendedDisplayCIELabValue
| VR=US, VM=3, Type 3.
DcmLongString | graphicLayerDescription
| VR=LO, VM=1, Type 3.

## Detailed Description

an item of the graphic layer sequence in a presentation state (internal use only).

This class manages the data structures comprising one item of the Graphic Layer Sequence in a Presentation State object.

## Member Function Documentation

## ◆ clone()

DVPSGraphicLayer* DVPSGraphicLayer::clone | ( |  | ) |
| inline

clone method.

Returns
  a pointer to a new DVPSGraphicLayer object containing a copy of this object.

## ◆ getGL()

const char* DVPSGraphicLayer::getGL | ( |  | ) |

get graphic layer name of this layer.

Returns
  a pointer to the graphic layer name

## ◆ getGLDescription()

const char* DVPSGraphicLayer::getGLDescription | ( |  | ) |

get graphic layer description of this layer.

Returns
  a pointer to the graphic layer description

## ◆ getGLOrder()

Sint32 DVPSGraphicLayer::getGLOrder | ( |  | ) |

gets the graphic layer order of this layer.

Returns
  the graphic layer order

## ◆ getGLRecommendedDisplayValueCIELab()

OFCondition DVPSGraphicLayer::getGLRecommendedDisplayValueCIELab | ( | Uint16 & | L,
|  | Uint16 & | a,
|  | Uint16 & | b
| ) |  |

gets the recommended CIELAB display value.

If no CIELAB display value is present, it is computed from the grayscale display value

Parameters

  L | returns the L* component of the recommended display value as unsigned 16-bit value containing a linear mapping of L* (0..100)
  a | returns the a* component of the recommended display value as unsigned 16-bit value containing a linear mapping of a* (-128..127)
  b | returns the b* component of the recommended display value as unsigned 16-bit value containing a linear mapping of b* (-128..127)

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getGLRecommendedDisplayValueGray()

OFCondition DVPSGraphicLayer::getGLRecommendedDisplayValueGray | ( | Uint16 & | gray | ) |

gets the recommended grayscale display value.

If the graphic layer contains an CIELAB display value but no grayscale display value, the CIELAB value is implicitly converted to grayscale.

Parameters

  gray | the recommended display value as an unsigned 16-bit P-value is returned in this parameter.

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getGLRecommendedDisplayValueRGB()

OFCondition DVPSGraphicLayer::getGLRecommendedDisplayValueRGB | ( | Uint16 & | r,
|  | Uint16 & | g,
|  | Uint16 & | b
| ) |  |

gets the recommended RGB display value.

This value is computed either from the CIELAB display value or from the Grayscale display value.

Parameters

  r | returns the R component of the recommended display value as unsigned 16-bit P-value
  g | returns the G component of the recommended display value as unsigned 16-bit P-value
  b | returns the B component of the recommended display value as unsigned 16-bit P-value

Returns
  EC_Normal upon success, an error code otherwise

## ◆ haveGLRecommendedDisplayValue()

OFBool DVPSGraphicLayer::haveGLRecommendedDisplayValue | ( |  | ) |

checks whether a recommended display value (grayscale, color or both) exists.

Returns
  OFTrue if a recommended display value exists

## ◆ read()

OFCondition DVPSGraphicLayer::read | ( | DcmItem & | dset | ) |

reads a graphic layer from a DICOM dataset.

The DICOM elements of the Graphic Layer item are copied from the dataset to this object. The completeness of the item (presence of all required elements, value multiplicity) is checked. If this method returns an error code, the object is in undefined state afterwards.

Parameters

  dset | the item of the GraphicLayerSequence from which the data is to be read

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ removeRecommendedDisplayValue()

void DVPSGraphicLayer::removeRecommendedDisplayValue | ( | OFBool | cielab,
|  | OFBool | monochrome
| ) |  |

removes recommended display values.

Parameters

  cielab | if true, the CIELAB recommended display value is removed
  monochrome | if true the monochrome recommended display value is removed

## ◆ setGL()

void DVPSGraphicLayer::setGL | ( | const char * | gl | ) |

set graphic layer name of this layer.

Parameters

  gl | a pointer to the graphic layer name, which is copied into this object.

## ◆ setGLDescription()

void DVPSGraphicLayer::setGLDescription | ( | const char * | glDescription | ) |

set graphic layer description of this layer.

Parameters

  glDescription | a pointer to the graphic layer description, which is copied into this object.

## ◆ setGLOrder()

void DVPSGraphicLayer::setGLOrder | ( | Sint32 | glOrder | ) |

set graphic layer order of this layer.

Parameters

  glOrder | the graphic layer order.

## ◆ setGLRecommendedDisplayValueCIELab()

void DVPSGraphicLayer::setGLRecommendedDisplayValueCIELab | ( | Uint16 | L,
|  | Uint16 | a,
|  | Uint16 | b
| ) |  |

set graphic layer recommended CIELAB display value of this layer.

This method does not affect (set or modify) the recommended grayscale display value which should be set separately.

Parameters

  L | the L* component of the recommended display value as unsigned 16-bit value containing a linear mapping of L* (0..100)
  a | the a* component of the recommended display value as unsigned 16-bit value containing a linear mapping of a* (-128..127)
  b | the b* component of the recommended display value as unsigned 16-bit value containing a linear mapping of b* (-128..127)

## ◆ setGLRecommendedDisplayValueGray()

void DVPSGraphicLayer::setGLRecommendedDisplayValueGray | ( | Uint16 | gray | ) |

set graphic layer recommended grayscale display value of this layer.

This method does not affect (set or modify) the recommended CIELAB display value which should be set separately.

Parameters

  gray | the recommended display value in P-values 0..0xffff.

## ◆ setGLRecommendedDisplayValueRGB()

void DVPSGraphicLayer::setGLRecommendedDisplayValueRGB | ( | Uint16 | r,
|  | Uint16 | g,
|  | Uint16 | b
| ) |  |

set graphic layer recommended CIELAB display value of this layer by converting RGB to CIELAB.

This method does not affect (set or modify) the recommended grayscale display value which should be set separately.

Parameters

  r | the red component of the recommended display value in P-values 0..0xffff.
  g | the green component of the recommended display value in P-values 0..0xffff.
  b | the blue component of the recommended display value in P-values 0..0xffff.

## ◆ write()

OFCondition DVPSGraphicLayer::write | ( | DcmItem & | dset | ) |

writes the graphic layer managed by this object to a DICOM dataset.

Copies of the DICOM element managed by this object are inserted into the DICOM dataset.

Parameters

  dset | the the item of the GraphicLayerSequence to which the data is written

Returns
  EC_Normal if successful, an error code otherwise.

The documentation for this class was generated from the following file:

- dcmpstat/include/dcmtk/dcmpstat/dvpsgl.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1